class UR_Weap_Link_D extends UR_Weap_Link;

/**
 * This function looks at how the beam is hitting and determines if this person is linkable
 * this method has been subclassed because the implementation in the upper class
 * was casting Who to UTOnslaughtObjective
 */
function AttemptLinkTo(Actor Who, PrimitiveComponent HitComponent)
{
        local UTGameObjective UTO;
        UTO = UTGameObjective(Who);
        if ( (UTO != none) && WorldInfo.Game.GameReplicationInfo.OnSameTeam(UTO,Instigator) )
        {

                                if(LinkedTo != Who)
                                {
                                        Unlink();
                                }
                                LinkedTo = UTO;
                                LinkedComponent = HitComponent;

        }
        if (LinkedTo != None)
        {
                SetFlashLocation(GetLinkedtoLocation());
        }
        else
     super.AttemptLinkTo(Who, HitComponent);
}

DefaultProperties
{
	// Weapon SkeletalMesh
	Begin Object Name=FirstPersonMesh
		Scale=3
	End Object

	WeaponProjectiles(0)=class'UR_Proj_MegaLink'
	ShotCost(0)= 0
	ShotCost(1)= 0
	BeamAmmoUsePerSecond = 0
	
  ItemName="UltraBlaster"
  PickupMessage="UltraBlaster"
	InventoryGroup=1
	bCanThrow=False
}